const menu = [
  'プログラミングスクールはやめとけ？',
  'おまえは何者じゃ？',
  'おすすめのプログラミングスクールは？',
  'どんな基準で言語を選ぶ？',
  'おすすめのプログラミング言語は？',
  '次のおすすめの言語は？',
];
const res = [
  '独学できる人はやめとけ。自分で数千円で書籍を買えば数十万円もするスクールに通わなくても1年やれば一定の知識とスキルは身に着くでしょう。ただ、途中で挫折しないことが条件‥',
  '40代のオッサン。むかしSEとPGやってたけど、ブログのためにわざわざプログラミングスクールに実費で入会を繰り返して、ガチのレビューを書いてまふ。',
  '3ヶ月受講したけどテックアカデミーの先生は良かった。次点でテックキャンプ、テックキャンプの先生はちょっと心もとなかった。',
  'WEB系ならHTML/CSS/JavaScript/PHP/Rubyあたり。業務系ならJava/Cあたり。組み込みならC。JAVAはWEBもAndroidもできる。AI・統計分析ならPython。iOSはSwift。AndroidはKotlin。',
  '初心者ならまずはHTMLとCSSをやるとよい。その後にJavaScriptかな。画面で見てすぐ結果がわかるしWeb上にたくさんの参考が載ってる。',
  'まずは1つの言語をつきつめるとよい。大抵のプログラミング言語は似たような構文をしているので。',
];

const chatTitle = "チャットボット";
const yourName = "光のプログラマー";
const yourRoll = "駆け出しプログラマーサポート";
const firstMsg = "当サイトにお越しいただきありがとうございます。気になるボタンを押してください。";
const closeTxt = "×";
const profileSize = { width : 50, height : 50}; //プロフィール画像サイズ
const copyRight = '<span><a href="https://happiant.co.jp/">(C) happiant</a></span>';

let ownURL, cssURL, profileImgURL, loadingImgURL;

let bodyTag;
let loadingImgDiv;
let modeFlg;

//window.onload = function onLoad() {
window.addEventListener('load', function(){

  modeFlg = false; //アイキャッチ表示か、チャット窓表示かのフラグ

  ownURL = getOwnUrl(); //chatbot.jsまでのURL
  cssURL = ownURL + 'chatbot.css'; //css読み込みURL
  profileImgURL = ownURL + 'profile.png'; //画像読み込みURL
  loadingImgURL = ownURL + 'loading.gif'; //ローディング用画像

  /*chatbot.cssを読み込む*/
  let linkTag = document.createElement("link");
  linkTag.href = cssURL;
	linkTag.rel = 'stylesheet';
	linkTag.type = 'text/css';
  let headTag = document.getElementsByTagName("head")[0];
  console.log(headTag);
  headTag.appendChild(linkTag);

  /*body要素を取得して*/
  bodyTag = document.getElementsByTagName('body')[0];

  //アイキャッチ
  var eyecatchDiv = document.createElement("div");
  eyecatchDiv.id = "chatbot-eyecatch-div";
  /* imgタグを使った画像でやる場合はこれだけど、divタグに背景画像で指定することにする
  var eyecatchImg = document.createElement("img");
  eyecatchImg.id = "chatbot-eyecatch-img";
  eyecatchImg.src = eyecatchImgUrl;
  eyecatchImg.width = eyecatchSize.width;
  eyecatchImg.height = eyecatchSize.height;
  eyecatchDiv.appendChild(eyecatchImg);
  eyecatchImg.addEventListener('click',toggleEyecathChat);
  */
  bodyTag.appendChild(eyecatchDiv);
  eyecatchDiv.addEventListener('click',toggleEyecathChat);



  //チャット窓
  //一番大枠
  var wakuDiv = document.createElement("div");
  wakuDiv.id = "chatbot-outline";



  //ヘッダー
  var headerDiv = document.createElement("div");
  headerDiv.id = "chatbot-header-div";
  wakuDiv.appendChild(headerDiv);

  //タイトル
  var titleDiv = document.createElement("div");
  titleDiv.id = "chatbot-title-div";
  titleDiv.textContent = chatTitle;
  headerDiv.appendChild(titleDiv);

  //閉じるボタン
  var closeDiv = document.createElement("div");
  closeDiv.id = "chatbot-close-div";
  closeDiv.textContent = closeTxt;
  closeDiv.addEventListener('click',toggleEyecathChat);
  headerDiv.appendChild(closeDiv);


  //本体
  var bodyDiv = document.createElement("div");
  bodyDiv.id = "chatbot-body-div";
  wakuDiv.appendChild(bodyDiv);


  //プロフィール
  var profileDiv = document.createElement("div");
  profileDiv.id = "chatbot-profile-div";
  bodyDiv.appendChild(profileDiv);

  //プロフィール画像
  var profileImg = document.createElement("img");
  profileImg.id = "chatbot-profile-img";
  profileImg.src = profileImgURL;
  profileImg.width = profileSize.width;
  profileImg.height = profileSize.height;
  profileDiv.appendChild(profileImg)

  //名前
  var nameDiv  = document.createElement("div");
  nameDiv.id = "chatbot-name-div";
  nameDiv.textContent = yourName;
  profileDiv.appendChild(nameDiv)

  //役職
  var rollDiv  = document.createElement("div");
  rollDiv.id = "chatbot-roll-div";
  rollDiv.textContent = yourRoll;
  profileDiv.appendChild(rollDiv)

  //メッセージ本体
  var msgDiv = document.createElement("div");
  msgDiv.id = "chatbot-message-div";
  bodyDiv.appendChild(msgDiv);


  //ローディング画像
  loadingImgDiv = document.createElement("div");// <div>要素を生成する
  loadingImgDiv.id = "loading";// id属性を設定する
  loadingImgDiv.style.display = 'none'; // ローディング画像を非表示にする
  loadingImg = document.createElement("img");
  loadingImg.src = loadingImgURL; // 画像ファイルを指定する
  loadingImg.alt = 'Loading...'; // 代替テキストを設定する
  loadingImgDiv.appendChild(loadingImg);// <img>要素を<div>要素の子要素として追加する
  msgDiv.appendChild(loadingImgDiv); // <div>要素をwakuDiv要素の子要素として追加する

  //ユーザーへのメッセージテキスト
  var msgP = document.createElement("p");
  msgP.id = "chatbot-message-p";
  msgP.textContent = firstMsg;
  msgDiv.appendChild(msgP);

  //メニュー
  var menuUl  = document.createElement("ul");
  menuUl.id = "chatbot-menu-ul";

  for (var i=0; i<menu.length; i++) {
    var menuLi = document.createElement("li");
    menuLi.id = "chatbot-menu-li-" + i;

    var menuRadio = document.createElement("input");
    menuRadio.id = "chatbot-menu-radio-" + i;
    menuRadio.type = "radio";
    menuRadio.name = "menu-group";
    menuRadio.value = menu[i];

    var menuLabel = document.createElement("label");
    menuLabel.htmlFor = menuRadio.id;
    menuLabel.textContent = menu[i];

    menuLi.appendChild(menuRadio);
    menuLi.appendChild(menuLabel);
    menuUl.appendChild(menuLi);
  }
  msgDiv.appendChild(menuUl);

  //////////////////////////
  // chatGPTの入力欄
  var inputTextDiv = document.createElement("div");
  inputTextDiv.id = "input-text-div";
  bodyDiv.appendChild(inputTextDiv);

  //inputタグ
  var inputText = document.createElement("input");
  inputText.type = "text";
  inputText.placeholder = "メッセージを入力してください";
  inputText.id = "input-text";

  //buttonタグ
  var btnSend = document.createElement("button");
  btnSend.id = "send-btn";
  btnSend.innerHTML = "送信";
  btnSend.addEventListener('click', chatgpt); //ボタンが押されたときのイベント

  // 生成したinputタグとbuttonタグをDOMに追加
  inputTextDiv.appendChild(inputText);
  inputTextDiv.appendChild(btnSend);

  //フッター
  var footerDiv = document.createElement("div");
  footerDiv.id = "chatbot-footer-div";
  footerDiv.innerHTML = copyRight;
  wakuDiv.appendChild(footerDiv);


  /*body要素に入れる*/
  bodyTag.appendChild(wakuDiv);


  /*イベント登録 メニュー選択時の挙動*/
  let radioBtns = document.querySelectorAll(`input[type='radio'][name='menu-group']`);
  for (let btn of radioBtns) {
        btn.addEventListener('change', function () { //ボタンにリスナー登録
        var index = btn.id.split('-')[3]; //メニュー番号

        //クエリ用のスペース
        var queryDiv = document.createElement("div");
        queryDiv.classList.add('query-div');
        queryDiv.textContent = menu[index];
        msgDiv.appendChild(queryDiv);

        //画面下部まで移動
        var bottom = msgDiv.scrollHeight - msgDiv.clientHeight;
        msgDiv.scroll(0, bottom);

        //クエリが表示された200ミリ秒後に回答を表示
        setTimeout(function() {
          //答え用のスペース
          var resDiv = document.createElement("div");
          resDiv.classList.add('res-div');
          resDiv.innerHTML = res[index];
          msgDiv.appendChild(resDiv);

          //画面下部まで移動
          //var bottom = msgDiv.scrollHeight - msgDiv.clientHeight;
          //msgDiv.scroll(0, bottom);
          msgDiv.scrollTop = msgDiv.scrollHeight;
        },200);

        });
  }

  toggleEyecathChat();

});


function chatgpt() {
  // ここにリクエストを送信するコードを記述する

  // inputの入力値を取得
  const prompt = document.getElementById('input-text').value;
  if(!prompt) return; //空だったら戻す

  
  document.getElementById('input-text').value = ""; //入力欄を空にする

  showLoading(); // ローディング画像を表示

  // XMLHttpRequestオブジェクトの作成
  const xhr = new XMLHttpRequest();

  const postURL = ownURL + 'chatgpt.php';

  // リクエストの送信方法を指定する
  xhr.open('POST', postURL);

  // リクエストヘッダーを設定する
  xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');

  // リクエストボディを設定
  // POSTリクエストの場合は、リクエストボディにパラメータを含める
  const params = "inputVal=" + encodeURIComponent(prompt);


  xhr.onerror = function() {
    console.error("リクエストエラー");
  };
  
  xhr.ontimeout = function() {
    console.error("タイムアウトエラー");
  };

  // レスポンスが受信されたときに呼び出される関数を定義する
  xhr.onload = function() {
    hideLoading(); // ローディング画像を非表示
    if (xhr.status === 200) {
      // レスポンスの処理
      /*
      console.log(xhr.responseText);
      var responseText = xhr.responseText;
      var responseObj = JSON.parse(responseText);
      var response = responseObj.choices[0].message.content;
      console.log(response);
      */


      //表示する枠div
      var msgDiv = document.getElementById("chatbot-message-div");

      //ユーザクエリの表示
      var queryDiv = document.createElement("div");
      queryDiv.classList.add('query-div');
      queryDiv.textContent = prompt;
      msgDiv.appendChild(queryDiv);


      //レスポンス用のdiv
      var resDiv = document.createElement("div");
      resDiv.classList.add('res-div');
      msgDiv.appendChild(resDiv);


      //GPTからのレスポンスを表示するdiv
      //var gptOutputDiv = document.createElement("div");
      //gptOutputDiv.classList.add('gpt-output-div');
      //msgDiv.appendChild(gptOutputDiv);

      //レスポンスデータを前処理
      var responseText = xhr.responseText;
      console.log(responseText);
      var responseObj = JSON.parse(responseText);
      var responseBody = responseObj.choices[0].message.content;
      

      // 1文字ずつ表示する
      var index = 0;
      var intervalId = setInterval(function() {
        if (index < responseBody.length) {
          resDiv.innerHTML += responseBody.charAt(index);
          index++;
          //画面下部まで移動
           msgDiv.scrollTop = msgDiv.scrollHeight;
        } else {
          clearInterval(intervalId);
        }
      }, 50);


      
    }
    else {
      // エラーの処理
      console.error(xhr.statusText);
    }
  };

  // リクエストを送信する
  xhr.send(params);

}

/*アイキャッチかチャット窓を表示*/
function toggleEyecathChat() {

  if(modeFlg) { //チャット窓を表示
    document.getElementById("chatbot-eyecatch-div").style.visibility = "hidden";
    var wakuDiv = document.getElementById("chatbot-outline");
    wakuDiv.style.visibility = "visible";
    wakuDiv.classList.add('chat-open-r');
  }else { //アイキャッチを表示
    document.getElementById("chatbot-eyecatch-div").style.visibility = "visible";
    var wakuDiv = document.getElementById("chatbot-outline");
    wakuDiv.style.visibility = "hidden";
    wakuDiv.classList.remove('chat-open-r');

  }

  modeFlg = !modeFlg;

}


function showLoading() {
  loadingImgDiv.style.display = 'block'; // ローディング画像を表示
}

function hideLoading() {
  loadingImgDiv.style.display = 'none'; // ローディング画像を非表示
}



/*chatbot.jsが設置されたURLを取得*/
function getOwnUrl() {
    var url;
    var scripts = document.getElementsByTagName("script");
    var i = scripts.length;
    while (i--) {
        var match = scripts[i].src.match(/(^|.*\/)chatbot\.js$/);
        if (match) {
            url = match[1];
            break;
        }
    }
    return url;
}
