<?php

 // config.phpファイルを読み込む
 require_once 'config.php';


// ユーザーが入力した文字列を取得
$prompt = $_POST["inputVal"];

// リクエスト用のURLを作成
$url = "https://api.openai.com/v1/chat/completions";

// リクエストのヘッダーを設定
$header = array(
    "Content-Type: application/json",
    "Authorization: Bearer " . API_KEY
);

$body = array(
    "model" => "gpt-3.5-turbo",
    "max_tokens" => 500,
    //"stop" => ["。", "。", "。"],
    "messages" => array(
        array(
            "role" => "system",
            "content" => "あなたはこのブログの管理人でAIアシスタントであると名乗ってください。あなたは優秀なプログラマーです。"
        ),
        array(
            "role" => "user",
            "content" => $prompt
        ),
    ),
);


$data = json_encode($body);

// cURLを使ってリクエストを送信
$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $url); //リクエスト先のURLを指定
curl_setopt($ch, CURLOPT_POST, true); //POSTリクエストを送信することを指定
curl_setopt($ch, CURLOPT_HTTPHEADER, $header); //HTTPヘッダを設定し
curl_setopt($ch, CURLOPT_POSTFIELDS, $data); //JSONデータを設定
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); //trueに設定することで、レスポンスを取
$response = curl_exec($ch); //実行結果を取得し
curl_close($ch); //リクエストを閉じる

// レスポンスをJavaScriptに
echo $response;

/***********************************
 * ここからDB処理
 */

// PDOインスタンスを作成
$dsn = 'mysql:host=' . DB_HOST . ';dbname=' . DB_NAME;
$pdo = new PDO($dsn, DB_USER, DB_PASS);

// 挿入する情報を定義
// $promptと、$responseはそのまま使う
$ip_address = $_SERVER['REMOTE_ADDR'];


// SQL文を作成
$sql = "INSERT INTO chattable (prompt, response, ip_address) VALUES (:prompt, :response, :ip_address)";

// プリペアドステートメントを準備
$stmt = $pdo->prepare($sql);

// プレースホルダに値をバインド
$stmt->bindValue(':prompt', $prompt);
$stmt->bindValue(':response', $response);
$stmt->bindValue(':ip_address', $ip_address);

// ステートメントを実行
try {
    $stmt->execute();
} catch(PDOException $e) {
    // エラーが発生した場合の処理
    error_log('chatgpt.php / DBエラー / ' . $e->getMessage() );
}
  
// SELECT文を実行して結果を取得する例
/*
$sql = "SELECT id, prompt, response, ip_address, date_added FROM chattable";
$stmt = $pdo->prepare($sql);
$stmt->execute();
$results = $stmt->fetchAll(PDO::FETCH_ASSOC);

// 結果を出力する例
foreach ($results as $row) {
  echo "ID: {$row['id']}, Prompt: {$row['prompt']}, Response: {$row['response']}, IP Address: {$row['ip_address']}, Date Added: {$row['date_added']}<br>";
}*/

?>
